﻿using System;
using System.IO;
using System.Windows.Forms;

namespace JPG2PDF
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        public string  SetNewName (string Dir, string OldFileName)
        {
            System.Collections.ArrayList fileList = new System.Collections.ArrayList();
            string NewFileName = string.Empty;
            string[] files = Directory.GetFiles(Dir);
            for (int i = 0; i < files.Length; i++)
            {
                if (files[i].Contains(OldFileName))
                {
                    fileList.Add(files[i]);
                }
            }
            NewFileName = Dir + "\\" + OldFileName + " _ " + fileList.Count + ".pdf";

            return NewFileName;
        }

        public void ImagensParaPDF(string ImagemCaminhoOrigem, string caminhoSaidaPDF)
        {
            string[] caminhoImagens = GetImageFiles(ImagemCaminhoOrigem);
            if (caminhoImagens.Length > 0)
            {
                this.progressBar1.Minimum = 1;
                this.progressBar1.Maximum = caminhoImagens.Length;
                string pdfpath = caminhoSaidaPDF + ImagemCaminhoOrigem.Substring(ImagemCaminhoOrigem.LastIndexOf("\\")) + ".pdf";
                if (File.Exists(pdfpath))
                {
                    //File.Delete(pdfpath);
                    pdfpath = SetNewName(caminhoSaidaPDF, ImagemCaminhoOrigem.Substring(ImagemCaminhoOrigem.LastIndexOf("\\") + 1));
                }
                using (var doc = new iTextSharp.text.Document())
                {
                    iTextSharp.text.pdf.PdfWriter.GetInstance(doc, new FileStream(pdfpath, FileMode.Create));
                    doc.Open();
                    foreach (var item in caminhoImagens)
                    {
                        iTextSharp.text.Image image = iTextSharp.text.Image.GetInstance(item);
                        //image.SetAbsolutePosition(30f, 30f);
                        if (this.chkScalebyImageSize.Checked)
                        {
                            image.ScaleToFit(doc.PageSize.Width - 60, doc.PageSize.Height - 60);
                        }
                        else
                        {
                            image.ScaleAbsoluteHeight(doc.PageSize.Height - 60);
                            image.ScaleAbsoluteWidth(doc.PageSize.Width - 60);
                        }
                        
                        doc.Add(image);
                        if (this.progressBar1.Maximum <= caminhoImagens.Length)
                            this.progressBar1.Increment(1);
                    }
                }
            }
            else
            {
                MessageBox.Show("Imagem não encontrada.", "Pare!", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }
        public string[] GetImageFiles(string ImageSource)
        {
            System.Collections.ArrayList Files = new System.Collections.ArrayList();
            string[] FilesArray = Directory.GetFiles(ImageSource);
            foreach (string file in FilesArray)
            {
                string extension = file.Substring(file.LastIndexOf(".")).ToUpper();
                if (extension.CompareTo(".JPG") == 0 || extension.CompareTo(".JPEG") == 0 || extension.CompareTo(".GIF") == 0)
                {
                    Files.Add(file);
                }
            }

            string[] returnFiles = new string[Files.Count];
            for (int i = 0; i < Files.Count; i++)
            {
                returnFiles[i] = Files[i].ToString();
            }

            return returnFiles;
        }

        private void button3_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void button4_Click(object sender, EventArgs e)
        {
            DialogResult Result = folderBrowserDialog1.ShowDialog();
            if (Result == System.Windows.Forms.DialogResult.OK)
            {
                this.txtImagesPath.Text = folderBrowserDialog1.SelectedPath.ToString();
            }
            else
            {
                MessageBox.Show("Você não escolhou uma pasta de saída.", "Parar!", MessageBoxButtons.OK, MessageBoxIcon.Error);
                this.txtImagesPath.Text = string.Empty;
            }

        }

        private void button5_Click(object sender, EventArgs e)
        {
            DialogResult Result = folderBrowserDialog1.ShowDialog();
            if (Result == System.Windows.Forms.DialogResult.OK)
            {
                this.txtPDFOutPath.Text = folderBrowserDialog1.SelectedPath.ToString();
            }
            else
            {
                MessageBox.Show("Você não escolhou uma pasta de saída.", "Parar!", MessageBoxButtons.OK, MessageBoxIcon.Error);
                this.txtPDFOutPath.Text = string.Empty;
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            this.txtPDFOutPath.Text = string.Empty;
            this.txtImagesPath.Text = string.Empty;
            this.progressBar1.Value = this.progressBar1.Minimum;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (!string.IsNullOrEmpty(this.txtImagesPath.Text) && !string.IsNullOrEmpty(this.txtPDFOutPath.Text))
            {
                ImagensParaPDF(this.txtImagesPath.Text, this.txtPDFOutPath.Text);
                MessageBox.Show("Conversão realizada com sucesso. Abra o arquivo PDF na pasta de destino para visualizar as imagens.");
            }
            else
            {
                if (string.IsNullOrEmpty(this.txtImagesPath.Text) && string.IsNullOrEmpty(this.txtPDFOutPath.Text))
                {
                    MessageBox.Show("SELECIONE a pasta ORIGEM e a de DESTINO.", "Parar", MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
                else
                {
                    if (string.IsNullOrEmpty(this.txtImagesPath.Text))
                    {
                        MessageBox.Show("SELECIONE a pasta Origem.", "Parar", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    }
                    else
                    {
                        MessageBox.Show("SELECIONE a pasta de Destino.", "Parar", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    }
                }
            }
        }

        private void chkScalebyImageSize_Click(object sender, EventArgs e)
        {
            if (this.chkScalebyImageSize.Checked == true)
            {
                this.chkScalebyPageSize.Checked = false;
            }
            else
            {
                this.chkScalebyPageSize.Checked = false;
                this.chkScalebyImageSize.Checked = true;
            }
        }

        private void chkScalebyPageSize_Click(object sender, EventArgs e)
        {
            if (this.chkScalebyPageSize.Checked == true)
            {
                this.chkScalebyImageSize.Checked = false;
            }
            else
            {
                this.chkScalebyImageSize.Checked = false;
                this.chkScalebyPageSize.Checked = true;
            }
        }

        //public void ImagesToPDF2()
        //{
        //    iTextSharp.text.Document document = new iTextSharp.text.Document();
        //    using (var stream = new FileStream("test.pdf", FileMode.Create, FileAccess.Write, FileShare.None))
        //    {
        //        iTextSharp.text.pdf.PdfWriter.GetInstance(document, stream);
        //        document.Open();
        //        using (var imageStream = new FileStream("test.jpg", FileMode.Open, FileAccess.Read, FileShare.ReadWrite))
        //        {
        //            var image = Image.GetInstance(imageStream);   //This is orignal method which is replaced by FromStream Method.
        //            document.Add(image);
                    
        //        }
        //        document.Close();
        //    }
        //}

        //public void ImagensParaPDF(string[] images, string pdfName)
        //{
        //    using (PdfDocument pdf = new PdfDocument())
        //    {
        //        for (int i = 0; i < images.Length; i++)
        //        {
        //            if (i > 0)
        //                pdf.AddPage();

        //            PdfPage page = pdf.Pages[i];
        //            string imagePath = images[i];
        //            PdfImage pdfImage = pdf.AddImage(imagePath);

        //            page.Width = pdfImage.Width;
        //            page.Height = pdfImage.Height;
        //            page.Canvas.DrawImage(pdfImage, 0, 0);
        //        }

        //        pdf.Save(pdfName);
        //    }
        //}

    }
}
